/// <summary> 
/// Performs a data query then formats an Html Report and displays it in the Web Browser
/// </summary> 
/// <param name="None">None Specified</param>
/// <returns>None</returns>
select * from example order by state save as datafile&(getpid())
use datafile&(getpid()).dbf in 0
copy to datafile&(getpid()).txt type delimited  
declare afieldList[ fldcount() ]
astore(afieldList, fldlist(), ',')

// declare some special symbols (html uses ampersand so do we)	
amp = chr(38) 
nbsp = amp + "nbsp;"  

// create the temporary html file
fp = fcreate("htmlfile&(getpid()).htm")
fwrite(fp, '<html>')  
fwrite(fp, '<style type="text/css">')
fwrite(fp, '.thstyle {color: #FFFFFF; font-weight: bold; }')
fwrite(fp, '</style>')
fwrite(fp, '<body background="images/wallpaper.gif" bgproperties="fixed">') 
fwrite(fp, '<table border="5" cellpadding="0" cellspacing="0" bordercolor="#0066CC" align="center">')
fwrite(fp, '<tr>')
fwrite(fp, '<td>')
fwrite(fp, '<table width="100%" height="100%" cellpadding="0" cellspacing="0" bgcolor="#E5E5F0" border=0px bordercolor="white">') 
fwrite(fp, '<tr  bgcolor="#0066CC">')
fwrite(fp, '<td align="center" colspan="&(fldcount())">')
fwrite(fp, '<b>')
fwrite(fp, '<label style="width:100%; height:29; color:white; font-family:SansSerif; font-weight:700; font-style:normal; font-size:24; filter:dropshadow; text-align:center">')
fwrite(fp, 'Demo HTML Report')
fwrite(fp, '</label>')
fwrite(fp, '</b>')
fwrite(fp, '</td>')
fwrite(fp, '</tr>')  

// diaplay column headings
fwrite(fp, '<tr bgcolor="#CCCCFF">')
	for j=1 to fldcount()
		fwrite(fp, '<td halign=left>')
		fwrite(fp, '<b>' + afieldlist[j] + '&(nbsp)&(nbsp)&(nbsp)&(nbsp)' + '</b>')
		fwrite(fp, '</td>')
    next
fwrite(fp, '<tr>') 
fwrite(fp, '<tr bgcolor="black" height="1px">' + replicate('<td></td>', fldcount()) + '</tr>')

// group subtotals by the STATE field 
last_state = state 
declare subtotals[3]
subtotals[1] = 0.0  	// limit
subtotals[2] = 0.0		// balance
subtotals[3] = 0.0		// available
m_limit = 0.0
m_balance = 0.0
m_available = 0.0 
	
// scan through the records generating the table rows and columns
goto top
   
// for all records...	   
for i=1 to reccount()+2
	if mod(i,2) = 0
    	rowcolor = "#CCFFFF"
    	altcolor = "#FFFFFF"
	else
		rowcolor = "#FFFFFF"        	
		altcolor = "#CCFFFF"
    endif

	// check for subtotal break
	if (state != last_state and i > 1) or (i > reccount())
		fwrite(fp, '<tr bgcolor="black" height="1px">' + replicate('<td></td>', fldcount()) + '</tr>')
		
		// display subtotals
		fwrite(fp, '<tr bgcolor="#CCCCFF" color="#333399">')
		
		if i <= reccount()+1
				fwrite(fp, '<td colspan="2" halign=left><b><font color="#333399">Sub-total for state: ' + last_state + '</font></b>')
		elseif i = reccount()+2
				fwrite(fp, '<td color="#333399" halign=left><b>Totals:</b>')
			fwrite(fp, replicate('<td>&(nbsp)</td>', 1))
        endif

		fwrite(fp, replicate('<td>&(nbsp)</td>', 7))
		
		fwrite(fp, '<td align=right>')
        tmpfld = currency(subtotals[1])
        fld = 'tmpfld'
		fwrite(fp, '<b><font color="#333399">' + etos(&fld)+'&(nbsp)&(nbsp)' + '</font><b>')
		fwrite(fp, '</td>')
    	
		fwrite(fp, '<td align=right>')
        tmpfld = currency(subtotals[2])
        fld = 'tmpfld'
		fwrite(fp, '<b><font color="#333399">' + etos(&fld)+'&(nbsp)&(nbsp)' + '</font><b>')
		fwrite(fp, '</td>')
    	
		fwrite(fp, '<td align=right>')
        tmpfld = currency(subtotals[3])
        fld = 'tmpfld'
		fwrite(fp, '<b><font color="#333399">' + etos(&fld)+'&(nbsp)&(nbsp)' + '</font><b>')
		fwrite(fp, '</td>') 
		fwrite(fp, replicate('<td>&(nbsp)</td>', 2))
		
		fwrite(fp, '</tr>')
		
		fwrite(fp, '<tr bgcolor="black" height="1px">' + replicate('<td></td>', fldcount()) + '</tr>')
		if i > reccount()+1
			fwrite(fp, '<tr bgcolor="white" height="1px">' + replicate('<td></td>', fldcount()) + '</tr>')
			fwrite(fp, '<tr bgcolor="black" height="1px">' + replicate('<td></td>', fldcount()) + '</tr>')
        endif
		
		fwrite(fp, '<tr colspan="&(fldcount())" bgcolor="&altcolor">')
		fwrite(fp, replicate('<td>&(nbsp)</td>', fldcount()))
		fwrite(fp, '</tr>') 

		if i = reccount()+1			
		    subtotals[1] = m_limit  		// limit
		    subtotals[2] = m_balance		// balance
		    subtotals[3] = m_available		// available
        	loop
        endif

	    subtotals[1] = 0.0  	// limit
	    subtotals[2] = 0.0		// balance
	    subtotals[3] = 0.0		// available
		
		if i > reccount()+1
        	exit
        endif
    endif

	// save subtotal values       	
   	last_state = state 
   	subtotals[1] = subtotals[1] + limit
   	subtotals[2] = subtotals[2] + balance
   	subtotals[3] = subtotals[3] + available 
   	m_limit  = m_limit + limit
   	m_balance = m_balance + balance
   	m_available = m_available + available

	// for all columns...
	fwrite(fp, '<tr bgcolor="&rowcolor">')
	for j=1 to fldcount()
		fld = afieldlist(j)
		if (upper(fld) = 'LIMIT' or upper(fld) = 'BALANCE' or upper(fld) = 'AVAILABLE')
        	tmpfld = currency(&fld)
        	fld = 'tmpfld'
			fwrite(fp, '<td align=right>')
		else            	
			fwrite(fp, '<td align=left>')
        endif
		fwrite(fp, etos(&fld)+"&(nbsp)&(nbsp)")
		fwrite(fp, '</td>')
    next   
    
	fwrite(fp, '</tr>')
	skip
next  

fwrite(fp, '</table>')
fwrite(fp, '</tr>')
fwrite(fp, '</td>')
fwrite(fp, '</table>')
fwrite(fp, '<br>')
fwrite(fp, '** End of report **')
fwrite(fp, '</body>')
fwrite(fp, '</html>') 
fclose(fp)

use
select example
showDocument("htmlfile&(getpid()).htm")

