/////////////////////////////////////////////////////////////////////////////////////  
public rpos
rpos = 1

// **********************************************************************************
// ** open up the example table to demonstrate Debug/Fields 
// **********************************************************************************
set sql to vfp
set message to "Select a menu option"
open database southwind

// TODO: This is a sample task
if file('example.dbf')
	set autoformat off
	use example  
endif	

myVar = "hello world"

// ********************************************************************************
// ** Menu procedures that are called when MenuItems are selected on the client
// ********************************************************************************

/// <summary> 
/// Handles data navigation for the Winform Demo
/// </summary> 
/// <param>cmd</param>
/// <returns>None</returns>
proc WinFormBar
	parameter cmd
	cmd = lower(cmd)
	if 	cmd = "first"
		rpos = 1 
		system.PutForm(m_formid, 'FirstName=Barry,LastName=Mavin,Street=Beverly Drive,City=Wokingham,State=Massachusetts,Zip=MA 01923,Requirements=Wants to know about WinForms integration')
	elseif cmd = "prev"  
		if rpos <> 1
			rpos = 1
			system.PutForm(m_formid, 'FirstName=Barry,LastName=Mavin,Street=Beverly Drive,City=Wokingham,State=Massachusetts,Zip=MA 01923,Requirements=Wants to know about WinForms integration')	
		endif
	elseif cmd = "next"
		if rpos <> 2   
			rpos = 2
			system.PutForm(m_formid, 'FirstName=Peter,LastName=Kelly,Street=Sea view drive,City=Danvers,State=New York,Zip=NY 01923,Requirements=Wants to know about Recital Mirage .NET')
		endif
	elseif cmd = "last"
		rpos = 2
		system.PutForm(m_formid, 'FirstName=Peter,LastName=Kelly,Street=Sea view drive,City=Danvers,State=New York,Zip=NY 01923,Requirements=Wants to know about Recital Mirage .NET')
    endif
endproc

// ********************************************************************************
// ** Event procedures specified as the VALID() clause on their respective objects
// ********************************************************************************

// handles Read exit key  
function v_checkExit  
	if lastkey() = ctrl('w') 
		mRet = 6
	else
		mRet = MessageBox("Do you want to exit the demo", 36, "Mirage Demo")
	endif
return mRet=6

// Handles PushButton clicks
function v_button
	do case
	case mbutton = 1
        show get 1 properties "method=moveFirstPage"
	case mbutton = 2
        show get 1 properties "method=movePreviousPage"
	case mbutton = 3
        show get 1 properties "method=moveNextPage"
	case mbutton = 4
        show get 1 properties "method=moveLastPage"
    endcase
return .t.

// TODO: Sample task note

// Handles the Quit PushButton
function v_quit
	dialog message "This will close your application window." + chr(10) + "Are you sure that you want to quit?"
	if lastkey() == 89	&& 'Yes'
		show object "system" properties "method=exit"
	endif
return .t.

// Handles the Window PushButton
function v_window
	define window example from 5,5 to 15,50 title "Sample Mirage Window" color w/b+
	activate window example
	?
	?
	? "        Mirage supports popup windows"
	show window example
	activate screen
return .t.

// Handles the PopupMenu PushButton
function v_popupmenu
	define popup example from 4,30 to 14,50 color n/w title "Sample Mirage Popup"
	define bar 1 of example prompt "One"
	define bar 2 of example prompt "Two"
	define bar 3 of example prompt "Three"
	define bar 4 of example prompt "Four"
	define bar 5 of example prompt "Five"
	define bar 6 of example prompt "Six"
	define bar 7 of example prompt "Seven"
	define bar 8 of example prompt "Eight"
	activate popup example
	dialog box "You selected item " + str(bar())
return .t.

// TODO: This is a note

// Handles the "View Source" PushButton
function v_print
	set macros off	
	printFile("c:\Program files\Recital\UAS\NETprocs\mirage_demo.prg?;
		      font=courier,plain,10&tabs=4&topMargin=50&autoNumber=true",;
		      "{FILE},,{DATE}",",-- Page {PAGE} --,")
	set macros on
return .t.	

// Handles ListBox double-click events
function v_list
    dialog box "You selected ListBox item "+ltrim(str(mlistbox))
return .t.

// Handles RadioButton selection events
function v_radio
    if mchoice = 2
    	dialog box "You selected the 'Single' RadioButton"
    endif
return .t.

// Handles CheckBox selection events
function v_checkbox
    if mcheckbox = 1
    	dialog box "You selected the CheckBox"
    endif
return .t.

// Handles Popup selection events
function v_popup
    if mpopup = 1		&& Cash selected
		dialog box "You selected 'Cash'"
    elseif mpopup = 2		&& Charge selected
		dialog box "You selected 'Charge'"
    elseif mpopup = 3		&& Net 30 selected
		dialog box "You selected 'Net 30'"
    elseif mpopup = 4		&& Net 60 selected
		dialog box "You selected 'Net 60'"
    endif
return .t.

// Handles ComboBox selection events
function v_combo
   	dialog box "You selected '"+mcombo+"'"
   	mtextfield = mcombo
   	show gets
   	flush
return .t.

// TODO: This is a test case

// Handles ImageButton selection events
function v_imagebtn
	do case
	case mimagebtn = 1
		dialog box "You clicked the 'Ok' button."
	case mimagebtn = 2
		dialog box "You clicked the 'Cancel' button."
	case mimagebtn = 3
		dialog box "You clicked the 'Update' button."
	case mimagebtn = 4
		dialog box "You clicked the 'Add' button."
    endcase
return .t.

// Handles ListBox focusin events
procedure list_select
	parameter id, text, item, itemcount
	private pos
	pos = at("|",text)
	if pos > 0
	    text = substr(text,1,pos-1)
	endif  
	@11,40 say rpad("Item "+alltrim(str(item))+" of " + ;
			alltrim(str(itemcount))+" ["+text+"]", 25)
	flush
return

// Handles ListBox focusout events
procedure list_deselect
	parameter id, text, item, itemcount
return

// ** START OF MAIN PROGRAM ** 
clear

// ** @...SAY
@0,0 fill to 1,79 color w/b properties "border=true;borderColor=red;borderSize=2;borderStyle=bottom;backcolor=#C3DAF9"
@0,22 say "Recital Mirage .NET Demo" properties "class=h1;pixely=34;backcolor=#C3DAF9" name "Banner"
 
// ** @...ListBox
declare lists[20]
lists[1]="One|This is 1|$10,000"
lists[2]="Two|This is 2|$10,000"
lists[3]="Three|This is 3|$10,000"
lists[4]="Four|This is 4|$10,000"
lists[5]="Five|This is 5|$10,000"
lists[6]="Six|This is 6|$10,000"
lists[7]="Seven|This is 7|$10,000"
lists[8]="Eight|This is 8|$10,000"
lists[9]="Nine|This is 9|$10,000"
lists[10]="Ten|This is 10|$10,000"
lists[11]="Eleven|This is 11|$10,000"
lists[12]="Twelve|This is 12|$10,000"
lists[13]="Thirteen|This is 13|$10,000"
lists[14]="Fourteen|This is 14|$10,000"
lists[15]="Fifteen|This is 15|$10,000"
lists[16]="Sixteen|This is 16|$10,000"
lists[17]="Seventeen|This is 17|$10,000"
lists[18]="Eighteen|This is 18|$10,000"
lists[19]="Nineteen|This is 19|$10,000"
lists[20]="Twenty|This is 20|$10,000"
store 0 to mlistbox
@2,0  say "ListBox:     " 
@3,0 get mlistbox ;
		from lists ;
		function "&" ;
		size 8,80 ;
		valid v_list() ;
		properties "columnTitles=One,Two,Three;titleBackColor=lightGray;;
			titleForeColor=black;columnWidths=30%,50%,*;;
			columnJustification=left,left,right;multi=true;;
			gridLines=true;gridColor=lightgray;stripecolor=#D8E4F8;;
			backColor=white;borderType=3d;;
			onSelect=list_select;onDeselect=list_deselect;editable=true"

// ** @...PushButton
store 1 to mbutton
@11,0 say "PushButton: " 
@11,14 get mbutton ;
		function "*HN <<;<;>;>>" ;
		valid v_button() ;
		size 1,4,0 ;
		font 'Helvetica',16 
@11,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @...line
@12,0 to 12,79 properties "style=image;image=line4.gif"

// ** @...RadioButton
store 1 to mchoice
@13,0 say "RadioButton: " get mchoice function "*RH None;Single;Double" ;
		valid v_radio()
@13,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @...CheckBox
store 1 to mcheckbox
@14,0 say "Checkbox:    " get mcheckbox function "*C Buy now!" ;
		valid v_checkbox()
@14,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @...Box
@13,45 to 15,59 properties "borderStyle=groupBox;text=Title"
@14,46 say "groupBox"
@13,63 to 15,79 properties "borderStyle=solid"
@14,64 say "solid"
@16,45 to 18,59 properties "borderStyle=recessed"
@17,46 say "recessed"
@16,63 to 18,79 properties "borderStyle=raised"
@17,64 say "raised"
@19,45 to 21,59 properties "borderStyle=etchedout"
@20,46 say "etchedOut"
@19,63 to 21,79 properties "borderStyle=etchedin"
@20,64 say "etchedIn"
 
// ** @...EditBox
store "This is a very long text string." to meditstring
@15,0 say "EditBox:" 
@15,14 edit meditstring size 3,30
@15,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @...Spinner
store 1 to mspinner
@18,0 say "Spinner:     " get mspinner spinner 1, -5 , 16
@18,12 say "bullet5.gif" bitmap properties "valign=center" 
                 
// ** @...BITMAP
@18,28 say "Image:        " 
@19,28 say "recital.jpg" bitmap size 5,16
                 
// ** @...GET
store space(10) to mtextfield
@19,0 say "TextField:   " get mtextfield noecho
@19,12 say "bullet5.gif" bitmap properties "valign=center" 

// **@...POPUP
store 1 to mpopup
@20,0 say "Popup:       " get mpopup;
		function "^ Cash;Charge;Net 30;Net 60" ;
		size 1,10;
		valid v_popup()
@20,12 say "bullet5.gif" bitmap properties "valign=center" 

// **@...ComboBox
store "January  " to mcombo
@21,0 say "ComboBox:    " get mcombo ;
		size 1,10 ;
		valid v_combo() ;
		choicelist "January,February,March,April,May,June,July,August,"+;
				"September,October,November,December"
@21,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @..SAY hyperlink
@22,0 say "Hyperlink:" 
@22,14 say "View Source";
		properties "forecolor=blue;fontUnderline=true;foreColor=blue;"+;
			   "dropShadow=false;url=http://www.recital.com/demo/mirage_demo.txt"
@22,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @..SAY Memo
@23,0 say "Memo:        " get notes
@23,12 say "bullet5.gif" bitmap properties "valign=center" 

@24,0 say "Other:" 
@24,12 say "bullet5.gif" bitmap properties "valign=center" 

// ** @...PushButton
store 1 to qbutton
@24,14 get qbutton ;
		function "*HN Quit" ;
		valid v_quit() ;
		size 1,4,0 ;
		font 'Helvetica',12 

// ** @...PushButton
store 1 to pbutton
@24,21 get pbutton ;
		function "*HN Print" ;
		valid v_print() ;
		size 1,4,0 ;
		font 'Helvetica',12 

// ** @...PushButton
store 1 to wbutton
@24,28 get wbutton ;
		function "*HN Window" ;
		valid v_window() ;
		size 1,6,0 ;
		font 'Helvetica',12 

// ** @...PushButton
store 1 to mbutton
@24,37 get mbutton ;
		function "*HN Popup" ;
		valid v_popupmenu() ;
		size 1,6,0 ;
		font 'Helvetica',12 

// **@...ImageButton
store 1 to mimagebtn
// REVISION: bmavin,04-Jul-03 04:27 PM,jomtien.recital.co.th,Changed button image names for XP
@24,46 say "ImageButton: " get mimagebtn;
		function "*HNB *ok22x22xp;*cancel22x22xp;*save22x22xp;*add22x22xp";
		valid v_imagebtn();
		size 1,1,1
@24,58 say "bullet5.gif" bitmap properties "valign=center" 

// ** READ controls on the form 
read valid v_CheckExit()   

// Call the "Quit" system method
system.Quit()

