#include  <stdio.h>
#include  <stdlib.h>

#include "Samples.h"
#include "dbapi.h"

// Recital API function address table
static	struct	API_FUNCTION_ADDRESS_TABLE *api_function_address_table = NULL;


// Add all functions to this structure as follows:
//    Recital Name,    C Function Name
//
// Make sure the last entry is NULL.
//
static	struct	API_SHARED_FUNCTION_TABLE api_function_table[6] = {
        {"schar", "fnSamplesCharacter"},
        {"stype", "fnSamplesType"},
        {"slog",  "fnSamplesLogical"},
        {"snum",  "fnSamplesNumeric"},
        {"sopen", "fnSamplesOpen"},
        {NULL, NULL}
} ;


// This function is used to define function addresses for API calls.
// IT SHOULD NEVER BE EDITED
int initAPI(struct	API_FUNCTION_ADDRESS_TABLE *function_address_table)
{
	api_function_address_table = function_address_table;
	return 0;
}

// This function is used to return the function names of the API.
// IT SHOULD NEVER BE EDITED
// Add functions to the api_function_table structure.
struct API_SHARED_FUNCTION_TABLE *getFunctions(void)
{
	return api_function_table;
}


//---------------------------------------------------------------------
//
// Recital Universal Application Server API Sample functions
//
//---------------------------------------------------------------------

// This is an example of passing a character parameter and returning one.
void fnSamplesCharacter(void)
{
	_retc(_parc(1));
}


// This is an example of passing a character parameter and returning one.
void fnSamplesNumeric(void)
{
	_retni(_parni(1));
}

// This is an example returns the data type of the parameter passed.
void fnSamplesType(void)
{
	char	result[10];

	switch (_parinfo(1)) {
	case API_CTYPE:
	    strcpy(result, "Character");
	    break;
	case API_NTYPE:
	    strcpy(result, "Numeric");
	    break;
	case API_LTYPE:
	    strcpy(result, "Logical");
	    break;
	case API_DTYPE:
	    strcpy(result, "Date");
	    break;
	case API_ATYPE:
	    strcpy(result, "Array");
	    break;
	default:
	    strcpy(result, "Unkown");
	    break;
	}

	_retc(result);
}


// This is an example returns "True" or Flase.
void fnSamplesLogical(void)
{
	char	result[10];

	if (_parl(1)) strcpy(result, "True");
	else strcpy(result, "False");

	_retc(result);
}


// This example opens a table.
void fnSamplesOpen(void)
{
	if (_parinfo(1) == API_CTYPE) {
	    _retni(COMMAND(_parc(1)));
	} else {
	    _retni(-1);
	}
}

