/*#============================================================================
 *# Copyright (C) 1991 Recital Corporation Inc.
 *# As an unpublished licenced proprietary work.
 *# All rights reserved worldwide.
 *#============================================================================
 *
 *      MODULE          : odbc_exa.c
 *
 *      PURPOSE         : Example ODBC compliant API
 *
 *      AUTHOR          : Recital Corporation Inc.
 *
 *      DATE            : 18-Nov-2002
 *
 *===========================================================================*/

#include <stdio.h>
#include <ctype.h>
#include <sqlext.h>

/*=============================================================================
 *
 * S Q L A l l o c E n v
 *
 * Allocate an environment handle.
 *
 *===========================================================================*/

SQLRETURN       SQLAllocEnv(henv)
SQLHENV         *henv;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L A l l o c C o n n e c t
 *
 * Allocate an connection  handle.
 *
 *===========================================================================*/

SQLRETURN       SQLAllocConnect(henv, hdbc)
SQLHENV         henv;
SQLHDBC         *hdbc;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L C o n n e c t
 *
 * Establish a connection to a database.
 *
 *===========================================================================*/

SQLRETURN       SQLConnect(
        hdbc, 
        szdsn, 
        cbdsn, 
        szuid, 
        cbuid, 
        szauthstr, 
        cbauthstr)
SQLHDBC         hdbc;
SQLCHAR         *szdsn;
SQLSMALLINT     cbdsn;
SQLCHAR         *szuid;
SQLSMALLINT     cbuid;
SQLCHAR         *szauthstr;
SQLSMALLINT     cbauthstr;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L D i s c o n n e c t
 *
 * Disconnect a connection to a database.
 *
 *===========================================================================*/

SQLRETURN       SQLDisconnect(hdbc)
SQLHDBC         hdbc;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L F r e e C o n n e c t
 *
 * Free connection to a database.
 *
 *===========================================================================*/

SQLRETURN       SQLFreeConnect(hdbc)
SQLHDBC         hdbc;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L F r e e E n v
 *
 * Free database environment.
 *
 *===========================================================================*/

SQLRETURN       SQLFreeEnv(henv)
SQLHENV         henv;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L T r a n s a c t
 *
 * Commits or rolls back the current transaction.
 *
 *===========================================================================*/

SQLRETURN       SQLTransact(henv, hdbc, type)
SQLHENV         henv;
SQLHDBC         hdbc;
SQLUSMALLINT    type;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L A l l o c S t m t
 *
 * Allocate a new statement an assicate it with connection handle.
 *
 *===========================================================================*/

SQLRETURN       SQLAllocStmt(hdbc, hstmt)
SQLHDBC         hdbc;
SQLHSTMT        *hstmt;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L E x e c u t e
 *
 * Execute a previously prepared dynamic SQL statement.
 *
 *===========================================================================*/

SQLRETURN       SQLExecute(hstmt)
SQLHSTMT        hstmt;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L S e t C u r s o r N a m e
 *
 * Associate a cursor name with a ststement handle.
 *
 *===========================================================================*/

SQLRETURN       SQLSetCursorName(hstmt, cursor_name, namelen)
SQLHSTMT        hstmt;
SQLCHAR         *cursor_name;
SQLSMALLINT     namelen;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L E x e c D i r e c t
 *
 * Prepare a and execute a SQL statement
 *
 *===========================================================================*/

SQLRETURN       SQLExecDirect(hstmt, sql_statement, stmtlen)
SQLHSTMT        hstmt;
SQLCHAR         *sql_statement;
SQLINTEGER      stmtlen;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L P r e p a r e
 *
 * Prepare a select statement
 *
 *===========================================================================*/

SQLRETURN       SQLPrepare(hstmt, sql_statement, stmtlen)
SQLHSTMT        hstmt;
SQLCHAR         *sql_statement;
SQLINTEGER      stmtlen;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L F r e e S t m t
 *
 * Close a cursor.
 *
 *===========================================================================*/

SQLRETURN       SQLFreeStmt(hstmt, type)
SQLHSTMT     hstmt;
SQLUSMALLINT type;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L F e t c h
 *
 * Advance cursor to next row.
 *
 *===========================================================================*/

SQLRETURN       SQLFetch(hstmt)
SQLHSTMT        hstmt;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L B i n d P a r m a m
 *
 * Bind an application variable to a parameter marker.
 *
 *===========================================================================*/

SQLBindParameter(hstmt,
                 ipar,
                 fparamtype,
                 fctype,
                 fsqltype,
                 cbcoldef,
                 ibscale,
                 rgbvalue,
                 cbvaluemax,
                 pcbvalue)
SQLHSTMT        hstmt;
SQLUSMALLINT     ipar;
SQLSMALLINT     fparamtype;
SQLSMALLINT     fctype;
SQLUINTEGER     fsqltype;
SQLINTEGER      cbcoldef;
SQLSMALLINT     ibscale;
SQLSMALLLINT    *rgbvalue;
SQLPOINTER      cbvaluemax;
SQLINTEGER      *pcbvalue;

    SQLHSTMT StatementHandle,
    SQLUSMALLINT ParameterNumber,
    SQLSMALLINT ValueType,
    SQLSMALLINT ParameterType,
    SQLUINTEGER LengthPrecision,
    SQLSMALLINT ParameterScale,
    SQLPOINTER ParameterValue,
    SQLINTEGER * StrLen_or_Ind);
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L E r r o r
 *
 * returns information about the most resent error.
 *
 *===========================================================================*/

SQLRETURN       SQLError(henv,
         hdbc,
         hstmt,
         szsqlstate,
         pfnativeerror,
         szerrormsg,
         cberrormsgmax,
         pcberrormsg)
SQLHENV         henv;
SQLHDBC         hdbc;
SQLHSTMT        hstmt;
SQLCHAR         *szsqlstate;
SQLINTEGER      *pfnativeerror;
SQLCHAR         *szerrormsg;
SQLSMALLINT     cberrormsgmax;
SQLSMALLINT     *pcberrormsg;
{
        return(SQL_ERROR);
}




/*=============================================================================
 *
 * S Q L D e s c r i b e C o l
 *
 * Return coloumn information.
 *
 *===========================================================================*/

SQLRETURN       SQLDescribeCol(hstmt,
               icol,
               szcolname,
               cbcolnamemax,
               pcbcolname,
               pfsqltype,
               pcbcoldef,
               pibscale,
               pfnullable)
SQLHSTMT        hstmt;
SQLSMALLINT     icol;
SQLCHAR         *szcolname;
SQLSMALLINT     cbcolnamemax;
SQLSMALLINT     *pcbcolname;
SQLSMALLINT     *pfsqltype;
SQLINTEGER      *pcbcoldef;
SQLSMALLINT     *pibscale;
SQLSMALLINT     *pfnullable;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L B i n d C o l
 *
 * Bind application storage space to columns in a result set.
 *
 *===========================================================================*/

SQLRETURN       SQLBindCol(
        hstmt, 
        icol,
        fctype,
        rgbvalue,
        cbvaluemax,
        pcbvalue)
SQLHSTMT        hstmt;
SQLSMALLINT     icol;
SQLSMALLINT     fctype;
SQLPOINTER      rgbvalue;
SQLINTEGER      cbvaluemax;
SQLINTEGER      *pcbvalue;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L S e t P a r  a m
 *
 * Bind application storage space to columns in a result set.
 *
 *===========================================================================*/

SQLRETURN       SQLSetParam(
        hstmt,
        ipar,
        fctype,
        fsqltype,
        cbparamdef,
        ibscale,
        rgbvalue,
        pcbvalue)
SQLHSTMT        hstmt;
SQLSMALLINT     ipar;
SQLSMALLINT     fctype;
SQLSMALLINT     fsqltype;
SQLINTEGER      cbparamdef;
SQLSMALLINT     ibscale;
SQLPOINTER      rgbvalue;
SQLINTEGER      *pcbvalue;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L N u m R e s u l t C o l s
 *
 * Returns the number of columns in a result set.
 *
 *===========================================================================*/

SQLRETURN       SQLNumResultCols(hstmt, pccol)
SQLHSTMT        hstmt;
SQLSMALLINT     *pccol;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L S p e c i a l C o l u m n s
 *
 * Set up fetch for special column names.
 *
 *===========================================================================*/

SQLSpecialColumns(hstmt, 
                  fcoltype,
                  sztablequalifier,
                  cbtablequalifier,
                  sztableowner,
                  cbtableowner,
                  sztablename,
                  cbtablename,
                  fscope,
                  fnullable)
HSTMT           hstmt;
SQLINTEGER      fcoltype;
SQLCHAR         *sztablequalifier;
SQLINTEGER      cbtablequalifier;
SQLCHAR         *sztableowner;
SQLINTEGER      cbtableowner;
SQLCHAR         *sztablename;
SQLINTEGER      cbtablename;
SQLINTEGER      fscope;
SQLINTEGER      fnullable;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L C o l A t t r i b u t e s
 *
 * Return descriptor information for a column
 *
 *===========================================================================*/

SQLRETURN SQLColAttributes( hstmt,
                  icol,
                  fdesctype,
                  rgbdesc,
                  cbdescmax,
                  pcbdesc,
                  pfdesc)
SQLHSTMT        hstmt;
SQLSMALLINT     icol;
SQLSMALLINT     fdesctype;
SQLCHAR         *rgbdesc;
SQLSMALLINT     cbdescmax;
SQLSMALLINT     *pcbdesc;
SQLINTEGER      *pfdesc;
{
        return(SQL_SUCCESS);
}




/*=============================================================================
 *
 * S Q L N u m P a r a m s
 *
 * Return the number of paramter markers
 *
 *===========================================================================*/

SQLRETURN       SQLNumParams(hstmt, pcpar)
SQLHSTMT        hstmt;
SQLINTEGER      *pcpar;
{
        return(SQL_SUCCESS);
}




/*=============================================================================
 *
 * S Q L D e s c r i b e P a r a m s
 *
 * Return the description of a paramter marker.
 *
 *===========================================================================*/

SQLDescribeParams(hstmt,
             ipar,
             pfsqltype,
             pcbcoldef,
             pibscale,
             pfnullable)
SQLHSTMT        hstmt;
SQLSMALLINT     ipar;
SQLSMALLINT     *pfsqltype;
SQLINTEGER      *pcbcoldef;
SQLSMALLINT     *pibscale;
SQLSMALLINT     *pfnullable;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L T a b l e s
 *
 * Returns the list of table names stored in a specified data source.
 *
 *===========================================================================*/

SQLTables(hstmt,
          sztablequalifier,
          cbtablequalifier,
          sztableowner,
          cbtableowner,
          sztablename,
          cbtablename,
          sztabletype,
          cbtabletype)
SQLHSTMT        hstmt;
SQLCHAR         *sztablequalifier;
SQLSMALLINT     cbtablequalifier;
SQLCHAR         *sztableowner;
SQLSMALLINT     cbtableowner;
SQLCHAR         *sztablename;
SQLSMALLINT     cbtablename;
SQLCHAR         *sztabletype;
SQLSMALLINT     cbtabletype;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L L o c k T a b l e
 *
 * Apply the specified lock to the table
 *
 *===========================================================================*/

SQLLockTable(hstmt, sztablename, ftype, fmode)
HSTMT           hstmt;
SQLCHAR         *sztablename;
SQLINTEGER      ftype;
SQLINTEGER      fmode;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L E x e c I m m e d i a t e
 *
 * Execute a SQL statement
 *
 *===========================================================================*/

SQLExecImmediate(hstmt, sql_statement, stmtlen)
SQLHSTMT        hstmt;
SQLCHAR         *sql_statement;
SQLINTEGER      stmtlen;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L S a v e P o i n t
 *
 * sets or rolls back a save point on the current transaction.
 *
 *===========================================================================*/

SQLSavePoint(hstmt, szsavepoint, type)
SQLHSTMT        hstmt;
SQLCHAR         *szsavepoint;
SQLSMALLINT     type;
{
        return(SQL_ERROR);
}




/*=============================================================================
 *
 * S Q L S e t L o c k i n g
 *
 * Change the transaction locking type.
 *
 *===========================================================================*/

SQLSetLocking(hstmt, sztablename, ftype, fmode)
HSTMT           hstmt;
SQLCHAR         *sztablename;
SQLINTEGER      ftype;
SQLINTEGER      fmode;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L G e t I n f o
 *
 * Returns general information about the DBMS currently connected.
 *
 *===========================================================================*/

SQLRETURN       SQLGetInfo(
        hdbc, 
        finfotype, 
        rgbinfovalue, 
        cbinfovaluemax, 
        pcbinfovalue)
HDBC            hdbc;
SQLSMALLINT     finfotype;
SQLPOINTER	rgbinfovalue;
SQLSMALLINT     cbinfovaluemax;
SQLSMALLINT     *pcbinfovalue;
{
        return(SQL_SUCCESS);
}



/*=============================================================================
 *
 * S Q L N a t i v e S q l
 *
 * returns the SQL string as a transalted by the driver.
 *
 *===========================================================================*/

SQLRETURN       SQLNativeSql(
        hdbc, 
        szsqlstrin, 
        cbsqlstrin, 
        szsqlstr, 
        cbsqlstrmax, 
        pcbsqlstr)
HDBC            hdbc;
SQLCHAR         *szsqlstrin;
SQLSMALLINT     cbsqlstrin;
SQLCHAR         *szsqlstr;
SQLSMALLINT     cbsqlstrmax;
SQLSMALLINT     *pcbsqlstr;
{
        return(SQL_SUCCESS);
}




/*=============================================================================
 *
 * S Q L S e t C o n n e c t O p t i o n
 *
 * sets options that govern aspect of connections
 *
 *===========================================================================*/

SQLRETURN       SQLSetConnectOption(
        hdbc, 
        fOption, 
        vParam)
HDBC            hdbc;
SQLSMALLINT     fOption;
SQLSMALLINT     vParam;
{
	return rc;
}




/*=============================================================================
 *
 * S Q L S e t S t m t O p t i o n
 *
 * sets options related to HSTMT
 *
 *===========================================================================*/

SQLRETURN       SQLGetStmtOption(
        hstmt, 
        fOption, 
        vParam)
SQLHSTMT        hstmt;
SQLSMALLINT     fOption;
SQLINTEGER      *vParam;
{
        return(SQL_ERROR);
}




/*=============================================================================
 *
 * S Q L S e t S t m t O p t i o n
 *
 * sets options related to HSTMT
 *
 *===========================================================================*/

SQLRETURN       SQLSetStmtOption(
        hstmt, 
        fOption, 
        vParam)
SQLHSTMT        hstmt;
SQLSMALLINT     fOption;
SQLSMALLINT     vParam;
{
        return(SQL_ERROR);
}




/*=============================================================================
 *
 * S Q L S e t P o s
 *
 * sets the cursor postion in a rowset
 *
 *===========================================================================*/

SQLRETURN       SQLSetPos(
        hstmt, 
	irow,
        fOption, 
        fLock)
SQLHSTMT        hstmt;
SDWORD 		irow;
SQLSMALLINT     fOption;
SQLSMALLINT     fLock;
{
        return(SQL_ERROR);
}



/*=============================================================================
 *
 * S Q L E x t e n d e d F e t c h
 *
 * Extends the functionality of SQLFetch()
 *
 *===========================================================================*/

SQLRETURN       SQLExtendedFetch(hstmt,fFetchType,irow,pcrow,rgfRowStatus)
SQLHSTMT        hstmt;
UWORD		fFetchType;
SDWORD 		irow;
UDWORD		*pcrow;
UWORD		*rgfRowStatus[];
{
        return(SQL_ERROR);
}


/*=============================================================================
 *
 *  S Q L R O W C O U N T
 *
 * build a scroll cursor
 *
 *===========================================================================*/

SQLRETURN	SQLRowCount(hstmt, rowcnt)
SQLHSTMT        hstmt;
SQLINTEGER	*rowcnt;
{
        return(SQL_ERROR);
}





/*=============================================================================
 *
 *  S Q L G E T D A T A
 *
 * Return data from a binary field
 *
 *===========================================================================*/

SQLRETURN	SQLGetData(hstmt, icol, fCType, rgbValue, cbValueMax,pcbValue)
HSTMT	hstmt;
UWORD	icol;
SWORD	fCType;
PTR	*rgbValue;
SDWORD	cbValueMax;
SDWORD  *pcbValue;
{
	return(SQL_NO_DATA);

}


char	*odbc_server_name()
{
	return("EXA");
}
