 //============================================================================
 // Copyright (C) 1986 - 2002 RECITAL CORPORATION Inc.
 // As an unpublished licensed proprietary work.
 // All rights reserved worldwide.
 //============================================================================
 //
 //	 MODULE          : template.txt
 //
 //      PURPOSE         : template code for a NET service.
 //
 //      AUTHOR          : Recital Corporation
 //
 //      DATE            : 10-dec-2002
 //
 //============================================================================
 //
 //	FUNCTIONS:
 //
 //	process_work()	:   This is the place to add your code 
 //
 //
 //	start()		:   Gets called when the service is started. Creates a 
 //			    filename.active and processes all actions while this
 //			    file exists.
 //
 //	stop()		:   Removes the filename.active file so the services will
 //			    stop when it next wakes to process commands
 //============================================================================

 //
 // this is the function to add your code that will be excuted by this NET service
 //

 function process_work

	//ToDO...

 return





//
// Start service function
//
function start

	// Check if active file already exists and return
	IF file(p_error_file)
  		ERASE &p_error_file
		IF file(p_active_file)
 			ERASE &p_active_file
		ENDIF
	ENDIF

	// Check if active file already exists and return
	IF file(p_active_file)
		return .f.
	ENDIF

	// Create active file
	fd = fcreate(p_active_file)
	IF ferror() = -1
		return .f.
    	ELSE
		fclose(fd)
	ENDIF

	// process transaction queue table
	DO WHILE file(p_active_file)
		sleep p_sleep_seconds
		process_work()
	ENDDO
   
return .t.


//
// Stop service function
//
function stop

	// Erase active file so service will stop
   	ERASE &p_active_file

	// return result
	IF file(p_active_file)
		rc = .f.
	ELSE
		rc = .t.
	ENDIF

return  rc


//
// Display errors
//
function displayError

	ON ERROR

	SAVE ERROR TO &p_error_file

	stop()
return

//
// Example service program.
//
function main
parameter action, sleepTime, NETServiceName

	// Setup exit call
	ON FINISH stop()

	// Setup error handler
	ON ERROR displayError()

	// Set up global variables
	PUBLIC p_active_file,p_error_file,p_sleep_seconds

	p_active_file = lower(basename(left(NETServiceName, at(".", NETServiceName) -1)+".active"))
	p_error_file = lower(basename(left(NETServiceName, at(".", NETServiceName) -1)+".error"))
	p_sleep_seconds = sleepTime

	// Change working directory and process specified function
	SET DEFAULT TO [C:\Program Files\Recital\UAS\NETservices]
	DO CASE

	// Start service
	CASE upper(action) = "START"
		result = start()

	// Stop service
	CASE upper(action) = "STOP"
		result = stop()

	// Unkown command
	OTHERWISE
	    result = .f.

	ENDCASE


return result


// 
// Main entry point takes the following two parameters:
// Action :-     Either START or STOP
// SleepTime :- Number of seconds the NET service will sleep 
//              between processing the process_work() function
// NETServiceName : - Name of the net service
// 
return(main(_PARA1, 10, procname()))
